#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct _osoba{

char ime[51];
char prezime[51];
char spol;
struct _osoba** prijatelji;
int brojPrijatelja;
int starost;
int brisati;
unsigned int oib;

}osoba;


int brisi(osoba* kuglana, int brojOsoba){
    int num=0,i,j,k,z, pronasao=0, oib;

    for(i=0;i<brojOsoba;i++){
            pronasao=0;
            num=0;
            for(j=0;j<kuglana[i].brojPrijatelja;j++){
                if(kuglana[i].prijatelji[j]->spol=='z')
                        num++;
            }
                if(num<2){
                    pronasao=1;
                    kuglana[i].brisati=1;
                }
    }

    for(i=0;i<brojOsoba;i++){
        if(kuglana[i].brisati==1){
                oib=kuglana[i].oib;

            for(j=0;j<kuglana[i].brojPrijatelja;j++){
                for(k=0;k<kuglana[i].prijatelji[j]->brojPrijatelja;k++)
                        if(kuglana[i].prijatelji[j]->prijatelji[k]->oib==oib){
                               for(z=k+1;z<kuglana[i].prijatelji[j]->brojPrijatelja;z++)
                                    kuglana[i].prijatelji[j]->prijatelji[z-1]=kuglana[i].prijatelji[j]->prijatelji[z];
                            kuglana[i].prijatelji[j]->brojPrijatelja--;
                            break;
                        }
            }

            free(kuglana[i].prijatelji);

            for(j=i+1;j<brojOsoba;j++)
                    kuglana[j-1]=kuglana[j];
                    i--;
                    brojOsoba--;
       }
    }
    return brojOsoba;
}


void ispisiSve(osoba* kuglana, int brojOsoba){
    int i;

    for(i=0;i<brojOsoba;i++){
        printf("%s, %s, %u, %d\n",kuglana[i].ime,kuglana[i].prezime, kuglana[i].oib,kuglana[i].brojPrijatelja);
    }
}


void ispisiUvjet(osoba* kuglana, int brojOsoba){

int i,j,k,z;
int presjek=0, unija=0,susjedi=0;
double postotak=0;

for(i=0;i<brojOsoba;i++){
    for(j=i+1;j<brojOsoba;j++){
            susjedi=0;
        presjek=0; unija=0;
        for(k=0;k<kuglana[i].brojPrijatelja;k++)
            for(z=0;z<kuglana[j].brojPrijatelja;z++){
                if(kuglana[i].prijatelji[k]->oib==kuglana[j].prijatelji[z]->oib){
                        presjek++;
                        break;
                }
            }
            if(presjek==0)
                printf("( %s %s - %s %s )\n",kuglana[i].ime,kuglana[i].prezime,kuglana[j].ime,kuglana[j].prezime);
    }
  }
}


void oslobodiMemoriju(osoba* kuglana, int brojOsoba){

    int i;

    for(i=0;i<brojOsoba;i++)
        free(kuglana[i].prijatelji);

    free(kuglana);

}

int main(void){


    char ime[51],prezime[51], spol;
    int godine;
    unsigned int oib;

    osoba* kuglana=NULL;
    int brojOsoba=0;

    FILE *in = fopen("osobe.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    while(fscanf(in,"%[^;];%[^;];%c;%d;%u ",ime,prezime,&spol,&godine,&oib)==5){

          kuglana=(osoba*) realloc(kuglana,++brojOsoba*sizeof(osoba));
          strcpy(kuglana[brojOsoba-1].ime,ime);
          strcpy(kuglana[brojOsoba-1].prezime,prezime);
          kuglana[brojOsoba-1].spol=spol;
          kuglana[brojOsoba-1].starost=godine;
          kuglana[brojOsoba-1].oib=oib;
          kuglana[brojOsoba-1].brojPrijatelja=0;
          kuglana[brojOsoba-1].prijatelji=NULL;
          kuglana[brojOsoba-1].brisati=0;
    }

    fclose(in);

      FILE *in1 = fopen("prijateljstva.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    int oib1, oib2,i;

    while(fscanf(in1,"%d %d",&oib1,&oib2)==2){
        int ind1=-1, ind2=-1;
        for(i=0;i<brojOsoba;i++){
            if(kuglana[i].oib==oib1)
                ind1=i;
            if(kuglana[i].oib==oib2)
                ind2=i;
            if(ind1!=-1 && ind2!=-1)
                break;
        }

        kuglana[ind1].prijatelji=(struct _osoba**) realloc(kuglana[ind1].prijatelji,++kuglana[ind1].brojPrijatelja*sizeof(osoba*));
        kuglana[ind1].prijatelji[kuglana[ind1].brojPrijatelja-1]=&kuglana[ind2];

        kuglana[ind2].prijatelji=(struct _osoba**) realloc(kuglana[ind2].prijatelji,++kuglana[ind2].brojPrijatelja*sizeof(osoba*));
        kuglana[ind2].prijatelji[kuglana[ind2].brojPrijatelja-1]=&kuglana[ind1];
    }

    ispisiUvjet(kuglana, brojOsoba);
    printf("\n\n");

    ispisiSve(kuglana,brojOsoba);
    brojOsoba=brisi(kuglana,brojOsoba);
    printf("\n\nmain - broj osoba: %d\n\n",brojOsoba);
    ispisiSve(kuglana,brojOsoba);

    fclose(in1);
    oslobodiMemoriju(kuglana,brojOsoba);

return 0;
}
