#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct _osoba{

char ime[51];
char prezime[51];
char spol;
struct _osoba** prijatelji;
int brojPrijatelja;
int starost;
int brisati;
unsigned int oib;

}osoba;


int brisi(osoba* restoran, int brojOsoba){
    int num=0,i,j,k,z, pronasao=0, oib;

    for(i=0;i<brojOsoba;i++){
            pronasao=0;
            num=0;
            for(j=0;j<restoran[i].brojPrijatelja;j++){
                if(restoran[i].prijatelji[j]->starost>70)
                        num++;
            }
                if(num>0){
                    pronasao=1;
                    restoran[i].brisati=1;
                }
    }

    for(i=0;i<brojOsoba;i++){
        if(restoran[i].brisati==1){
                oib=restoran[i].oib;

            for(j=0;j<restoran[i].brojPrijatelja;j++){
                for(k=0;k<restoran[i].prijatelji[j]->brojPrijatelja;k++)
                        if(restoran[i].prijatelji[j]->prijatelji[k]->oib==oib){
                               for(z=k+1;z<restoran[i].prijatelji[j]->brojPrijatelja;z++)
                                    restoran[i].prijatelji[j]->prijatelji[z-1]=restoran[i].prijatelji[j]->prijatelji[z];
                            restoran[i].prijatelji[j]->brojPrijatelja--;
                            break;
                        }
            }

            free(restoran[i].prijatelji);

            for(j=i+1;j<brojOsoba;j++)
                    restoran[j-1]=restoran[j];
                    i--;
                    brojOsoba--;
       }
    }
    return brojOsoba;
}


void ispisiSve(osoba* restoran, int brojOsoba){
    int i;

    for(i=0;i<brojOsoba;i++){
        printf("%s, %s, %u, %d\n",restoran[i].ime,restoran[i].prezime, restoran[i].oib,restoran[i].brojPrijatelja);
    }
}


void ispisiUvjet(osoba* restoran, int brojOsoba){

int i,j,k,z;
int presjek=0, unija=0,susjedi=0;
double postotak=0;

for(i=0;i<brojOsoba;i++){
    for(j=i+1;j<brojOsoba;j++){
            susjedi=0;
        presjek=0; unija=0;
        for(k=0;k<restoran[i].brojPrijatelja;k++)
            for(z=0;z<restoran[j].brojPrijatelja;z++){
                if(restoran[i].prijatelji[k]->oib==restoran[j].prijatelji[z]->oib){
                        presjek++;
                        break;
                }
            }

            unija=restoran[i].brojPrijatelja+restoran[j].brojPrijatelja-presjek;

            postotak=(double)presjek/(double)unija;
            if(postotak<=0.4)
                printf("( %s %s - %s %s )\n",restoran[i].ime,restoran[i].prezime,restoran[j].ime,restoran[j].prezime);
    }
  }
}


void oslobodiMemoriju(osoba* restoran, int brojOsoba){

    int i;

    for(i=0;i<brojOsoba;i++)
        free(restoran[i].prijatelji);

    free(restoran);

}

int main(void){


    char ime[51],prezime[51], spol;
    int godine;
    unsigned int oib;

    osoba* restoran=NULL;
    int brojOsoba=0;

    FILE *in = fopen("osobe.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    while(fscanf(in,"%[^;];%[^;];%c;%d;%u ",ime,prezime,&spol,&godine,&oib)==5){

          restoran=(osoba*) realloc(restoran,++brojOsoba*sizeof(osoba));
          strcpy(restoran[brojOsoba-1].ime,ime);
          strcpy(restoran[brojOsoba-1].prezime,prezime);
          restoran[brojOsoba-1].spol=spol;
          restoran[brojOsoba-1].starost=godine;
          restoran[brojOsoba-1].oib=oib;
          restoran[brojOsoba-1].brojPrijatelja=0;
          restoran[brojOsoba-1].prijatelji=NULL;
          restoran[brojOsoba-1].brisati=0;
    }

    fclose(in);

      FILE *in1 = fopen("prijateljstva.txt", "rt");
    if (in == NULL)
    {
        printf("Greska prilikom otvaranja datoteke za citanje\n");
        exit(1);
    }

    int oib1, oib2,i;

    while(fscanf(in1,"%d %d",&oib1,&oib2)==2){
        int ind1=-1, ind2=-1;
        for(i=0;i<brojOsoba;i++){
            if(restoran[i].oib==oib1)
                ind1=i;
            if(restoran[i].oib==oib2)
                ind2=i;
            if(ind1!=-1 && ind2!=-1)
                break;
        }

        restoran[ind1].prijatelji=(struct _osoba**) realloc(restoran[ind1].prijatelji,++restoran[ind1].brojPrijatelja*sizeof(osoba*));
        restoran[ind1].prijatelji[restoran[ind1].brojPrijatelja-1]=&restoran[ind2];

        restoran[ind2].prijatelji=(struct _osoba**) realloc(restoran[ind2].prijatelji,++restoran[ind2].brojPrijatelja*sizeof(osoba*));
        restoran[ind2].prijatelji[restoran[ind2].brojPrijatelja-1]=&restoran[ind1];
    }

    ispisiUvjet(restoran, brojOsoba);
    printf("\n\n");

    ispisiSve(restoran,brojOsoba);
    brojOsoba=brisi(restoran,brojOsoba);
    printf("\n\nmain - broj osoba: %d\n\n",brojOsoba);
    ispisiSve(restoran,brojOsoba);

    fclose(in1);
    oslobodiMemoriju(restoran,brojOsoba);

return 0;
}
