/*  Napisite funkciju prototipa, char* ponavljanje(char** popis, int n), koja vraca pokazivac na string,
izgradjen od praznog stringa na sljedeci nacin. Varijabla popis pokazuje na vec postojeci niz
u kojem je zapisano n rijeci. Korisnik upisuje rijeci (po jednu u redu), sve dok ne upise znak '#'.
Za svaku ucitanu rijec r, funkcija ponavljanje pretrazuje zadani niz od n rijeci i trazi prvu rijec w,
takvu da se rijec r moze dobiti konacnim ponavljanjem rijeci w. Ako nadje takvu rijec w, onda tu rijec
treba dodati na kraj stringa koji se izgradjuje, tako da je medju dodanim rijecima po jedan razmak.
U suprotnom, string se ne mijenja. Smijete pretpostaviti da ucitane rijeci nemaju vise od 80 znakova.
Primjer: rijec r=jojjojjoj dobivena je trostrukim ponavljanjem rijeci w = joj.  */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int usporedi_ponavljanje(char *r, char *w)
{
    int  dr=strlen(r),dw=strlen(w), n=dr/dw;
    if(dr%dw) return 0;

    char t[81]; strcpy(t,w);
    while(--n) strcat(t,w);

    if(strcmp(t,r)==0) return 1;
    return 0;
}



char* ponavljanje(char **popis, int n)
{
    int i,t=0;              /*t sluzi da pri prvom upisu ne dodamo razmak*/
    char r[81];
    char *s; s=malloc(sizeof(char)); s[0]='\0';
    char c;
    while(1){
        scanf("%s",r);      scanf("%c",&c); /*cistimo ulaz od znaka za prijelaz u novi red*/
        if(strcmp(r,"#")==0) return s;
        for(i=0;i<n;i++) { if(usporedi_ponavljanje(r,popis[i])) break; }
        if(i==n)  continue;
        s=realloc(s,(strlen(s)+1+t+strlen(popis[i]))*sizeof(char));
        if(t) strcat(s," "); strcat(s,popis[i]); t=1;
    }
    return s;
}


/*ostatak nije potreban za kolokvij*/


char** kreiraj(int *n)
{
    *n=0;
    char r[15];
    char **p=NULL;
    char c;
    while(1){
        scanf("%s",r);  scanf("%c",&c);  /*ciscenje ulaza od znaka za novi red*/
        if(strcmp(r,"#")==0) return p;
        ++(*n);
        p=realloc(p,(*n)*sizeof(char*));
        p[*n-1]=realloc(p[*n-1],(strlen(r)+1)*sizeof(char));
        p[*n-1][0]='\0';
        strcat(p[*n-1],r);
    }
    return p;
}

int main (void)
{
    int n;
    char **p=kreiraj(&n),*s;
    s=ponavljanje(p,n);
    printf("kreirani niz je \n%s",s);
    return 0;
}




