/*
Napisite funkciju prototipa char* zamjena(char** rjecnik, int k),
koja vraca pokazivac na string, izgraden od praznog stringa na sljedeci nacin.
Varijabla rjecnik pokazuje na vec postojeci niz u kojem je zapisano k rijeci.
Korisnik upisuje rijeci (po jednu u redu), sve dok ne upise znak '!'.
Za svaku ucitanu rijec r, funkcija zamjena pretrazuje zadani niz od k rijeci
 i trazi prvu rijec w, takvu da postoje podrijeci a i b, za koje vrijedi r = ab i w = ba.
Ako nade takvu rijec w, onda tu rijec treba dodati na kraj stringa koji se izgraduje,
tako da je medu dodanim rijecima po jedan razmak. U suprotnom, string se ne mijenja.
Smijete pretpostaviti da ucitane rijeci nemaju vise od 80 znakova.
Primjer: za rijec r=karma, trazena rijec moze biti w=makar (tada je a=kar, b=ma).
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int usporedi_zamjena(char *r, char *w)
{
    int i,t,dr=strlen(r), dw=strlen(w);
    if(dr!=dw) return 0;
    char x[81],y[81];
    for(i=0;i<dr; i++){
        strcpy(x,r+i);  strcat(x,w+dr-i);
        strcpy(x,w+dr-i);  strcat(x,r+i);
        if((strcmp(r,x)==0)&&(strcmp(w,y)==0)) {t=1; break;}
    }
    return t;
}


char* zamjena(char **rjecnik, int n)
{
    int i,t=0;              /*t sluzi da pri prvom upisu ne dodamo razmak*/
    char r[81];
    char *s; s=malloc(sizeof(char)); s[0]='\0';
    char c;
    while(1){
        scanf("%s",r);      scanf("%c",&c); /*cistimo ulaz od znaka za prijelaz u novi red*/
        if(strcmp(r,"#")==0) return s;
        for(i=0;i<n;i++) { if(usporedi_zamjena(r,rjecnik[i])) break; }
        if(i==n)  continue;
        s=realloc(s,(strlen(s)+1+t+strlen(rjecnik[i]))*sizeof(char));
        if(t) strcat(s," "); strcat(s,rjecnik[i]); t=1;
    }
    return s;
}


/*ostatak nije potreban za kolokvij*/


char** kreiraj(int *n)
{
    *n=0;
    char r[15];
    char **p=NULL;
    char c;
    while(1){
        scanf("%s",r);  scanf("%c",&c);  /*ciscenje ulaza od znaka za novi red*/
        if(strcmp(r,"#")==0) return p;
        ++(*n);
        p=realloc(p,(*n)*sizeof(char*));
        p[*n-1]=realloc(p[*n-1],(strlen(r)+1)*sizeof(char));
        p[*n-1][0]='\0';
        strcat(p[*n-1],r);
    }
    return p;
}

int main (void)
{
    int n;
    char **p=kreiraj(&n),*s;
    s=zamjena(p,n);
    printf("kreirani niz je \n%s",s);
    return 0;
}


