/*
Napisite funkciju prototipa char* inverzija(char** niz, int l),
koja vraca pokazivac na string, izgraden od praznog stringa na
sljedeci nacin. Varijabla niz pokazuje na vec postojeci niz u kojem
je zapisano l rijeci. Korisnik upisuje rijeci (po jednu u redu),
sve dok ne upise znak ; .Za svaku ucitanu rijec x, funkcija inverzija
pretrazuje zadani niz od l rijeci i trazi prvu rijec y, takvu da postoje
a i b, podrijeci od x, za koje vrijedi x=ab i y=ab^t, gdje je b^t
invertirana (naopaka) rije\v{c} od b. Ako nade takvu rijec y, onda tu rijec
treba dodati na kraj stringa koji se izgraduje, tako da je medu dodanim
rijecima po jedan razmak. U suprotnom, string se ne mijenja. Smijete pretpostaviti
da ucitane rijeci nemaju vise od 80 znakova.
Primjer: za rije\vc x=iznad, trazena rijec moze biti y =izdan (tada je a=iz, b=nad.
*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int usporedi_inverzija(char *x, char *y)
{
    int i,t,j,dx=strlen(x), dy=strlen(y);
    if(dx!=dy) return 0;
    for(i=0;i<dx; i++){
        t=1;
        for(j=0;j<i;j++) if(x[j]!=y[j]) t=0;
        if(t) {for(j=i; j<dx; j++) if(x[j]!=y[i+dx-1-j]) t=0;}
        if(t) return 1;
        }
    return t;
}


char* inverzija(char **niz, int n)
{
    int i,t=0;              /*t sluzi da pri prvom upisu ne dodamo razmak*/
    char r[81];
    char *s; s=malloc(sizeof(char)); s[0]='\0';
    char c;
    while(1){
        scanf("%s",r);      scanf("%c",&c); /*cistimo ulaz od znaka za prijelaz u novi red*/
        if(strcmp(r,"#")==0) return s;
        for(i=0;i<n;i++) { if(usporedi_inverzija(r,niz[i])) break; }
        if(i==n)  continue;
        s=realloc(s,(strlen(s)+1+t+strlen(niz[i]))*sizeof(char));
        if(t) strcat(s," "); strcat(s,niz[i]); t=1;
    }
    return s;
}


/*ostatak nije potreban za kolokvij*/


char** kreiraj(int *n)
{
    *n=0;
    char r[15];
    char **p=NULL;
    char c;
    while(1){
        scanf("%s",r);  scanf("%c",&c);  /*ciscenje ulaza od znaka za novi red*/
        if(strcmp(r,"#")==0) return p;
        ++(*n);
        p=realloc(p,(*n)*sizeof(char*));
        p[*n-1]=realloc(p[*n-1],(strlen(r)+1)*sizeof(char));
        p[*n-1][0]='\0';
        strcat(p[*n-1],r);
    }
    return p;
}

int main (void)
{
    int n;
    char **p=kreiraj(&n),*s;
    s=inverzija(p,n);
    printf("kreirani niz je \n%s",s);
    return 0;
}


